HDU 4238 You Are the One

You Are the One

Time Limit: 2000/1000 MS (Java/Others) Memory Limit: 32768/32768 K (Java/Others)
Total Submission(s): 2753 Accepted Submission(s): 1267

Problem Description
  The TV shows such as You Are the One has been very popular. In order to meet the need of boys who are still single, TJUT hold the show itself. The show is hold in the Small hall, so it attract a lot of boys and girls. Now there are n boys enrolling in. At the beginning, the n boys stand in a row and go to the stage one by one. However, the director suddenly knows that very boy has a value of diaosi D, if the boy is k-th one go to the stage, the unhappiness of him will be (k-1)*D, because he has to wait for (k-1) people. Luckily, there is a dark room in the Small hall, so the director can put the boy into the dark room temporarily and let the boys behind his go to stage before him. For the dark room is very narrow, the boy who first get into dark room has to leave last. The director wants to change the order of boys by the dark room, so the summary of unhappiness will be least. Can you help him?

Input
  The first line contains a single integer T, the number of test cases. For each case, the first line is n (0 < n <= 100)
  The next n line are n integer D1-Dn means the value of diaosi of boys (0 <= Di <= 100)

Output
  For each test case, output the least summary of unhappiness .

Sample Input
2
  
5
1
2
3
4
5

5
5
4
3
2
2

Sample Output
Case #1: 20
Case #2: 24

题意:
有一个序列,每个ai代表一个屌丝值k,ai的不开心值是
k*(i-1),但是你可以用一个小房子改变序列的顺序。

小房子一次可以放很多人,像一个栈,先进后出,通过这个栈来调整序列的顺序。一开始我总是纠结每个房子可以放很多人,所以状态转移方程想不出来。看了题解
,状态转移方程是考虑一个人插到k个人之后,可以得到的最优解。一个人是子状态,小房子可以放多个人是一个全局的状态,不应该考虑到总的状态,所以要从子状态开始。

dp[i][j]表示i到j最小的不开心值,对于第i个人,他可能有两种状态,一是没有放到房子里,二是放到房子里。
放到房子里,假设插到k个人后面,那么就可以得出两个子状态dp[i+1][i+k-1]和dp[i+k][j],这里还要注意dp[i][j]表示从i到j这段区间不考虑i前面的大区间。因为i插到了第k位,所以屌丝值要a[i]*(k-1),dp[i+k][j]由于要前面排上了k位,所以要加上(s[j]-s[k+i-1])*k);

关于区间DP,可以参照这个博客
http://blog.csdn.net/dacc123/article/details/50885903

//
//  main.cpp
//  区间DP 1004
//
//  Created by 陈永康 on 16/3/4.
//  Copyright &#169; 2016年 陈永康. All rights reserved.
//
#include <iostream>
#include <string.h>
#include <stdlib.h>
#include <algorithm>
#include <math.h>

using namespace std;
#define MAX 10000000
int n;
int a[105];
int dp[105][105];
int s[105];
int main()
{
    int t;
    scanf("%d",&t);
    int cas=0;
    while(t--)
    {
        scanf("%d",&n);
        s[0]=0;
        for(int i=1;i<=n;i++)
        {
            scanf("%d",&a[i]);
            s[i]=s[i-1]+a[i];
        }
        for(int i=0;i<=104;i++)
            for(int j=0;j<=104;j++)
            {
                if(i>=j)
                    dp[i][j]=0;
                else
                    dp[i][j]=MAX;
            }
        for(int l=1;l<=n-1;l++)
        {
            for(int i=1;i+l<=n;i++)
            {
                int j=i+l;
                for(int k=1;k<=j-i+1;k++)
                {
                    dp[i][j]=min(dp[i][j],dp[i+1][i+k-1]+dp[i+k][j]+a[i]*(k-1)+(s[j]-s[k+i-1])*k);
                }
            }
        }
        printf("Case #%d: %d
",++cas,dp[1][n]);
    }
    return 0;
}
原文地址:https://www.cnblogs.com/dacc123/p/8228772.html